// get data (stored checked items) from database for each level
let otherResults = []   // only holds 1 row per user with 5 fields
let level1Results = []  // holds assignments, one per row, for level
let level1ResultsAB = []  // holds AB assignments, one per row, for level
let level2Results = []
let level2ResultsAB = []
let level3Results = []
let level3ResultsAB = []

let level4Results = []
let level4ResultsAB = []
let level5Results = []
let level5ResultsAB = []
let level6Results = []
let level6ResultsAB = []
let level7Results = []
let level7ResultsAB = []
let results = ""
let resultsDB = []


function getAssignNames(results) {
    // use to get assignment names from database results and just save names
    let levelResults = []
    for (i = 0; i < results.length; i++) 
       levelResults[i] = results[i][2]
    return levelResults
}


levelItems.onshow=function(){
    // FINISH for levels 2 - 7
  
  function selectFromDB(theQuery) {
  // query database and return results
    let theResults = []
    let req1 = ""

    req1 = Ajax("https://ormond.creighton.edu/courses/375/ajax-connection.php", "POST", "host=ormond.creighton.edu&user=clc90595&pass=BIA375&database=clc90595&query=" + theQuery)
      if (req1.status == 200) { //transit worked.
          theResults = JSON.parse(req1.responseText)
          return theResults
          // brings back array with one array in it - row for that netID
          //console.log(`The results length for otherdata are: ${otherResults[0].length} and array is ${otherResults}`)
          //console.log(`The first item is ${otherResults[0][0]} - should be 11.`)   
      } else
        NSB.MsgBox("Network error: " + req1.status)
  } // end of function

  /* **** FIRST DO OTHER Data ******************************* */
  // 1. get from database (tokens, midtermScore, project level, extraXP) and put in array 
  query = "SELECT * FROM otherdata WHERE netID = '" + netID + "'"   // gets one row
  otherResults = selectFromDB(query)

  // 2. Fill the Other container controls with database values stored in array 
    // Remember, case i = 0 is ID #, case i = 1 is netID and length is 6
        for (i = 2; i < 6; i++) 
           if (otherResults[0][i] != null) 
                switch(i) {
                    case 2:  //token count 
                        inptCountsTokens.value = otherResults[0][2]
                        break;
                    case 3:  // midterm 
                        inptCountsMidterm.value = otherResults[0][3]
                        break;
                    case 4:  // project level 
                        switch(otherResults[0][4]) {
                          case "Advanced":
                            rdoCountsProjectType.value = 0
                            break
                          case "Intermediate":
                            rdoCountsProjectType.value = 1
                            break
                          case "Essential": 
                            rdoCountsProjectType.value = 2
                            break
                        } // end inside switch
                        break
                    case 5:  //extra XP count
                        inptCountsEXP.value = otherResults[0][5]
                        break;
                    default:
                        alert("Error in Other Data retrieval")
              } // outside switch
    
    
/* **** NEXT DO LEVEL1 Data ******************************* */
    // Fill LEVEL 1 container Required Assign controls and level1Results array from DB
    // 1. Get the items from the database for Level 1 assignments (required) and put 
    // into Level 1 array
    query = "SELECT * FROM assignments WHERE netID = '" + netID + "' AND level = 1 ORDER BY level" 
    resultsDB = selectFromDB(query)
    level1Results = getAssignNames(resultsDB)
    
    for (i = 0; i <= level1Results.length; i++) {
        switch(level1Results[i]) {   //assign name
        case "Fixit 1": 
            chkbxReq1.setValue(0,true)
            break
        case "Fixit 2": 
            chkbxReq1.setValue(1,true)
            break
        case "Fixit 3": 
            chkbxReq1.setValue(2,true)
            break
        case "Fixit 4": 
            chkbxReq1.setValue(3,true)
            break
        case "GP Fixit 3-4": 
            chkbxReq1.setValue(4,true)
            break
        case "Perf": 
            chkbxReq1.setValue(5,true)
            break
        }  // switch
    } // for loop

/* **** NOW DO LEVEL!AB data ******************************* */
    // Now fill AB LEVEL 1 container Assign controls and level1ResultsAB array from DB
    
    // 1. Get the items from the assignmentsAB database for Level 1 AB assignments and put 
    // into Level 1 AB array
    query = "SELECT * FROM assignmentsAB WHERE netID = '" + netID + "' AND level = 1 ORDER BY level" 
    resultsDB = selectFromDB(query)
    level1ResultsAB = getAssignNames(resultsDB)

    // array of arrays; each row is an array in results array
    //alert(query)
    //console.log(`before switch, level1ResultsAB[0] is ${level1ResultsAB}`)
    for (i = 0; i <= level1ResultsAB.length; i++) {
        switch(level1ResultsAB[i]) {   //assign name
        case "ExtraXP Fixit 4": 
            chkbxAB1.setValue(0,true)
            break
        case "Level Up Fixit": 
            chkbxAB1.setValue(1,true)
            break
        }  // switch
    } // for loop


/* **** NOW DO LEVEL 2 data ******************************* */
    // Fill LEVEL 2 container Required Assign controls and level1Results array from DB
    // 1. Get the items from the database for Level 2 assignments (required) and put 
    // into Level 2 array
    query = "SELECT * FROM assignments WHERE netID = '" + netID + "' AND level = 2 ORDER BY level" 
    resultsDB = selectFromDB(query)
    level2Results = getAssignNames(resultsDB)
    
    for (i = 0; i <= level2Results.length; i++) {
        switch(level2Results[i]) {   //assign name
        case "GP Fixit 5": 
            chkbxReq2.setValue(0,true)
            break
        case "Fixit 5": 
            chkbxReq2.setValue(1,true)
            break
        case "GP Fixit 6": 
            chkbxReq2.setValue(2,true)
            break
        case "Fixit 6": 
            chkbxReq2.setValue(3,true)
            break
        case "Perf": 
            chkbxReq2.setValue(4,true)
            break
        }  // switch
    } // for loop

/* **** NOW DO LEVEL2AB data ******************************* */
    // Now fill AB LEVEL 2 container Assign controls and level2ResultsAB array from DB
    
    // 1. Get the items from the assignmentsAB database for Level 2 AB assignments and put 
    // into Level 2 AB array
    query = "SELECT * FROM assignmentsAB WHERE netID = '" + netID + "' AND level = 2 ORDER BY level" 
    resultsDB = selectFromDB(query)
    level2ResultsAB = getAssignNames(resultsDB)

    // array of arrays; each row is an array in results array
    //alert(query)
    //console.log(`before switch, level2ResultsAB[0] is ${level2ResultsAB}`)
    for (i = 0; i <= level2ResultsAB.length; i++) {
        switch(level2ResultsAB[i]) {   //assign name
        case "ExtraXP Fixit 5": 
            chkbxAB2.setValue(0,true)
            break
        case "ExtraXP Fixit 6": 
            chkbxAB2.setValue(1,true)
            break
        case "Level Up Fixit": 
            chkbxAB2.setValue(2,true)
            break
        }  // switch
    } // for loop


/* **** NOW DO LEVEL 3 data ******************************* */
    // Fill LEVEL 3 container Required Assign controls and level1Results array from DB
    // 1. Get the items from the database for Level 3 assignments (required) and put 
    // into Level 3 array
    query = "SELECT * FROM assignments WHERE netID = '" + netID + "' AND level = 3 ORDER BY level" 
    resultsDB = selectFromDB(query)
    level3Results = getAssignNames(resultsDB)
    
    for (i = 0; i <= level3Results.length; i++) {
        switch(level3Results[i]) {   //assign name
        case "GP Fixit 7": 
            chkbxReq3.setValue(0,true)
            break
        case "Fixit 7": 
            chkbxReq3.setValue(1,true)
            break
        case "GP Fixit 8": 
            chkbxReq3.setValue(2,true)
            break
        case "Fixit 8": 
            chkbxReq3.setValue(3,true)
            break
        case "Perf": 
            chkbxReq3.setValue(4,true)
            break
        }  // switch
    } // for loop

/* **** NOW DO LEVEL3AB data ******************************* */
    // Now fill AB LEVEL 3 container Assign controls and level3ResultsAB array from DB
    
    // 1. Get the items from the assignmentsAB database for Level 3 AB assignments and put 
    // into Level 3 AB array
    query = "SELECT * FROM assignmentsAB WHERE netID = '" + netID + "' AND level = 3 ORDER BY level" 
    resultsDB = selectFromDB(query)
    level3ResultsAB = getAssignNames(resultsDB)

    // array of arrays; each row is an array in results array
    //alert(query)
    //console.log(`before switch, level3ResultsAB[0] is ${level3ResultsAB}`)
    for (i = 0; i <= level3ResultsAB.length; i++) {
        switch(level3ResultsAB[i]) {   //assign name
        case "ExtraXP Fixit 7": 
            chkbxAB3.setValue(0,true)
            break
        case "ExtraXP Fixit 7": 
            chkbxAB3.setValue(1,true)
            break
        case "Level Up Fixit": 
            chkbxAB3.setValue(2,true)
            break
        }  // switch
    } // for loop

// FINISH for Levels 4, 5, 6, 7


}   // end of event


//**********************************************//
//**********************************************//
//**********************************************//
//**********************************************//


btnSaveRefresh.onclick=function(){  
    // Need to save newly checked items to database
  
    // Code here works with 2 arrays:  array with the checked assignments retrieved 
    // from the database
    // and the array with all currently checked items in the level
    // difference between these two are the newly checked but not saved to database items
  
    // function to tell you difference between contents of two arrays
    Array.prototype.diff = function(a) {
    return this.filter(function(i) {return !(a.indexOf(i) > -1)})
    }
  
  /* ****** Other Data Save to DB ************** */
    // Update database with Other Container data that is in the form
    // 1. Get all of the date from the controls in the Other container
    if (inptCountsTokens.value >= 0)
        otherResults[0][2] = inptCountsTokens.value
    else {
        NSB.MsgBox("You cannot enter a negative Token count, so your change was not saved.")
        inptCountsTokens.value = otherResults[0][2]
    }

    if (inptCountsMidterm.value >= 0 && inptCountsMidterm.value < 101) 
            otherResults[0][3] = inptCountsMidterm.value
    else {
          NSB.MsgBox("You cannot enter a Midterm grade less than 0 or greater than 100, so your change was not saved.")
          inptCountsMidterm.value = otherResults[0][3]
    }
    
    if (inptCountsEXP.value <= 12 && inptCountsEXP.value >= 0)
        otherResults[0][5] = inptCountsEXP.value
    else {
        NSB.MsgBox("You cannot enter more than 12 or less than 0 for the Extra XP value, so your change was not saved.")
        inptCountsEXP.value = otherResults[0][5]
    }
    
    switch(rdoCountsProjectType.value) {   // get checked index value
        case 0: 
            otherResults[0][4] = "Advanced"
            break
        case 1: 
            otherResults[0][4] = "Intermediate"
            break
        case 2: 
            otherResults[0][4] = "Essential"
            break
  }

    // 3. Now insert new items that were newly changed/added in Other data form into the DB
    //query = "UPDATE otherdata SET tokenCount = " + otherResults[0][2] + ", midtermScore = " + otherResults[0][3] + ", projectLevel = '" + otherResults[0][4] + "' where netID = '" + netID + "'"
    console.log(`Before update, otherResults[0]1-4 are: ${otherResults[0][2]}, ${otherResults[0][3]}, ${otherResults[0][4]}, ${otherResults[0][5]}`)
    console.log(`in save other midterm is ${otherResults[0][3]}`)
    query = "UPDATE otherdata SET tokenCount = " + otherResults[0][2] + ",midtermScore = " + otherResults[0][3] + ",projectLevel = '" + otherResults[0][4] + "',extraxp = " + otherResults[0][5] + " WHERE netID = '" + netID + "'"
    req = Ajax("https://ormond.creighton.edu/courses/375/ajax-connection.php", "POST", "host=ormond.creighton.edu&user=clc90595&pass=BIA375&database=clc90595&query=" + query)
    if (req.status == 200) { //transit worked.
       console.log(`the req.response is ${req.responseText}`)
        if (req.responseText == 500) {   // means the insert succeeded
            NSB.MsgBox("Your Tokens, Midterm, Project level changes have been saved.")
        } else 
            NSB.MsgBox("There was a problem saving your Tokens, Midterm, and/or Project level changeschanges. Please close the app and try again.")
    } else {
        // transit error
        NSB.MsgBox("Save error: " + req.status)
    }

 
  /* ****** LEVEL 1 Data Save to DB ************** */
    // 1. Get all of the items that are currently checked for Level 1 container
    let allChecked = []
    for (i = 0; i < 6; i++) { // six required checkboxes in the Level 1 container
      if (chkbxReq1.getValue(i) == true) {
         switch(i) {   // make sure item is in the 'new' array already 
                        // ie. (avoid adding it twice)
            case 0: 
               if (!allChecked.includes("Fixit 1"))
                  allChecked.push("Fixit 1")
               break
            case 1: 
               if (!allChecked.includes("Fixit 2"))
                  allChecked.push("Fixit 2")
               break
            case 2: 
               if (!allChecked.includes("Fixit 3"))
                  allChecked.push("Fixit 3")
               break
            case 3: 
               if (!allChecked.includes("Fixit 4"))
                  allChecked.push("Fixit 4")
               break
            case 4: 
               if (!allChecked.includes("GP Fixit 3-4"))
                  allChecked.push("GP Fixit 3-4")
               break
            case 5: 
               if (!allChecked.includes("Perf"))
                  allChecked.push("Perf")
               break            
        } // switch
    //console.log("level1 all current choices: " + allChecked)
    //console.log("what was previously in database: " + level1Results)
        } // if getValue is true
    } // for loop

     // 2. *** Now check to see if the contents of two arrays 
     // (all currently checked allChecked and from DB level1Results)
     // are the same. 
     // If they are NOT the same, get the elements that are different 
     // (ie. not from the database)- so essentially pick out the 
     // new ones the user added this runtime.
 
     let diffFromDatabase = []
     if(!(JSON.stringify(allChecked.sort())==JSON.stringify(level1Results.sort()))) {
        diffFromDatabase = allChecked.diff(level1Results) 
     //console.log("diff from DB is " + diffFromDatabase)
            
    // 3. Now insert the difference (new items that were newly checked) into the DB
        for (i = 0; i < diffFromDatabase.length; i++) {
            query = "INSERT INTO assignments (netID,assignmentName,level) VALUES ('" + netID + "','" + diffFromDatabase[i] + "'," + 1 + ")"
            req = Ajax("https://ormond.creighton.edu/courses/375/ajax-connection.php", "POST", "host=ormond.creighton.edu&user=clc90595&pass=BIA375&database=clc90595&query=" + query)
            if (req.status == 200) { //transit worked.
            //console.log(`added to db: diffFromDatabase[i] when i = ${i}: ${diffFromDatabase[i]} `)
                if (req.responseText == 500) {   // means the insert succeeded
                    //let result = JSON.parse(req.responseText)
                    NSB.MsgBox("Your changes have been saved.")
                } else
                    NSB.MsgBox("There was a problem saving your changes. Please close the app and try again.")
            } else {
                // transit error
                NSB.MsgBox("Save error: " + req.status)
            }
        }  // for loop
    } // if JSON.stringify...
    
    
    
  /* ****** LEVEL 1AB Data Save to DB ************** */
    // 1. Get all of the items that are currently checked for Level 1 AB 
    allChecked = []
    for (i = 0; i < 2; i++) { // 2  checkboxes in the Level 1 AB 
      if (chkbxAB1.getValue(i) == true) {
         switch(i) {   // make sure item is in the 'new' array already 
                        // ie. (avoid adding it twice)
            case 0: 
               if (!allChecked.includes("ExtraXP Fixit 4"))
                  allChecked.push("ExtraXP Fixit 4")
               break
            case 1: 
               if (!allChecked.includes("Level Up Fixit"))
                  allChecked.push("Level Up Fixit")
               break
        } // switch
    //console.log("level1AB all current choices: " + allChecked)
    //console.log("what was previously in database: " + level1ResultsAB)
        } // if getValue is true
    } // for loop

     // 2. *** Now check to see if the contents of two arrays 
     // (all currently checked allChecked and from DB level1Results)
     // are the same. 
     // If they are NOT the same, get the elements that are different 
     // (ie. not from the database)- so essentially pick out the 
     // new ones the user added this runtime.
 
     diffFromDatabase = []
     if(!(JSON.stringify(allChecked.sort())==JSON.stringify(level1ResultsAB.sort()))) {
        diffFromDatabase = allChecked.diff(level1ResultsAB) 
     console.log("diff from DB is " + diffFromDatabase)
            
    // 3. Now insert the difference (new items that were newly checked) into the DB
        for (i = 0; i < diffFromDatabase.length; i++) {
            query = "INSERT INTO assignmentsab (netID,assignABName,level) VALUES ('" + netID + "','" + diffFromDatabase[i] + "'," + 1 + ")"
            req = Ajax("https://ormond.creighton.edu/courses/375/ajax-connection.php", "POST", "host=ormond.creighton.edu&user=clc90595&pass=BIA375&database=clc90595&query=" + query)
            if (req.status == 200) { //transit worked.
            console.log(`added to db: diffFromDatabase[i] when i = ${i}: ${diffFromDatabase[i]} `)
                if (req.responseText == 500) {   // means the insert succeeded
                    //let result = JSON.parse(req.responseText)
                    NSB.MsgBox("Your changes have been saved.")
                } else
                    NSB.MsgBox("There was a problem saving your changes. Please close the app and try again.")
            } else {
                // transit error
                NSB.MsgBox("Save error: " + req.status)
            }
        }  // for loop
    } // if JSON.stringify...
    
    
    
    
/* ****** LEVEL 2 Data Save to DB ************** */

    // 1. Get all of the items that are currently checked for Level 2 container
    allChecked = []
    for (i = 0; i < 5; i++) { // five required checkboxes in the Level 2 container
      if (chkbxReq2.getValue(i) == true) {
         switch(i) {   // make sure item is in the 'new' array already 
                        // ie. (avoid adding it twice)
            case 0: 
               if (!allChecked.includes("GP Fixit 5"))
                  allChecked.push("GP Fixit 5")
               break
            case 1: 
               if (!allChecked.includes("Fixit 5"))
                  allChecked.push("Fixit 5")
               break
            case 2: 
               if (!allChecked.includes("GP Fixit 6"))
                  allChecked.push("GP Fixit 6")
               break
            case 3: 
               if (!allChecked.includes("Fixit 6"))
                  allChecked.push("Fixit 6")
               break
            case 4: 
               if (!allChecked.includes("Perf"))
                  allChecked.push("Perf")
               break
        } // switch
    //console.log("level2 all current choices: " + allChecked)
    //console.log("what was previously in database: " + level2Results)
        } // if getValue is true
    } // for loop

     // 2. *** Now check to see if the contents of two arrays 
     // (all currently checked allChecked and from DB level2Results)
     // are the same. 
     // If they are NOT the same, get the elements that are different 
     // (ie. not from the database)- so essentially pick out the 
     // new ones the user added this runtime.
 
     diffFromDatabase = []
     if(!(JSON.stringify(allChecked.sort())==JSON.stringify(level2Results.sort()))) {
        diffFromDatabase = allChecked.diff(level2Results) 
     //console.log("L2 REg diff from DB is " + diffFromDatabase)
            
    // 3. Now insert the difference (new items that were newly checked) into the DB
        for (i = 0; i < diffFromDatabase.length; i++) {
            query = "INSERT INTO assignments (netID,assignmentName,level) VALUES ('" + netID + "','" + diffFromDatabase[i] + "'," + 2 + ")"
            req = Ajax("https://ormond.creighton.edu/courses/375/ajax-connection.php", "POST", "host=ormond.creighton.edu&user=clc90595&pass=BIA375&database=clc90595&query=" + query)
            if (req.status == 200) { //transit worked.
            //console.log(`added to db: diffFromDatabase[i] when i = ${i}: ${diffFromDatabase[i]} `)
                if (req.responseText == 500) {   // means the insert succeeded
                    //let result = JSON.parse(req.responseText)
                    NSB.MsgBox("Your changes have been saved.")
                } else
                    NSB.MsgBox("There was a problem saving your changes. Please close the app and try again.")
            } else {
                // transit error
                NSB.MsgBox("Save error: " + req.status)
            }
        }  // for loop
    } // if JSON.stringify...
    
  /* ****** LEVEL 2AB Data Save to DB ************** */
    // 1. Get all of the items that are currently checked for Level 2 AB 
    allChecked = []
    for (i = 0; i < 3; i++) { // 3  checkboxes in the Level 2 AB 
      if (chkbxAB2.getValue(i) == true) {
         switch(i) {   // make sure item is in the 'new' array already 
                        // ie. (avoid adding it twice)
            case 0: 
               if (!allChecked.includes("ExtraXP Fixit 5"))
                  allChecked.push("ExtraXP Fixit 5")
               break
            case 1: 
               if (!allChecked.includes("ExtraXP Fixit 6"))
                  allChecked.push("ExtraXP Fixit 6")
               break

            case 2: 
               if (!allChecked.includes("Level Up Fixit"))
                  allChecked.push("Level Up Fixit")
               break
        } // switch
    //console.log("level2AB all current choices: " + allChecked)
    //console.log("what was previously in database: " + level2ResultsAB)
        } // if getValue is true
    } // for loop

     // 2. *** Now check to see if the contents of two arrays 
     // (all currently checked allChecked and from DB level3Results)
     // are the same. 
     // If they are NOT the same, get the elements that are different 
     // (ie. not from the database)- so essentially pick out the 
     // new ones the user added this runtime.
 
     diffFromDatabase = []
     if(!(JSON.stringify(allChecked.sort())==JSON.stringify(level2ResultsAB.sort()))) {
        diffFromDatabase = allChecked.diff(level2ResultsAB) 
     console.log("L2AB diff from DB is " + diffFromDatabase)
            
    // 3. Now insert the difference (new items that were newly checked) into the DB
        for (i = 0; i < diffFromDatabase.length; i++) {
            query = "INSERT INTO assignmentsab (netID,assignABName,level) VALUES ('" + netID + "','" + diffFromDatabase[i] + "'," + 2 + ")"
            req = Ajax("https://ormond.creighton.edu/courses/375/ajax-connection.php", "POST", "host=ormond.creighton.edu&user=clc90595&pass=BIA375&database=clc90595&query=" + query)
            if (req.status == 200) { //transit worked.
            console.log(`added to db: diffFromDatabase[i] when i = ${i}: ${diffFromDatabase[i]} `)
                if (req.responseText == 500) {   // means the insert succeeded
                    //let result = JSON.parse(req.responseText)
                    NSB.MsgBox("Your changes have been saved.")
                } else
                    NSB.MsgBox("There was a problem saving your changes. Please close the app and try again.")
            } else {
                // transit error
                NSB.MsgBox("Save error: " + req.status)
            }
        }  // for loop
    } // if JSON.stringify...



/* ****** LEVEL 3 Data Save to DB ************** */

    // 1. Get all of the items that are currently checked for Level 3 container
    allChecked = []
    for (i = 0; i < 5; i++) { // five required checkboxes in the Level 3 container
      if (chkbxReq3.getValue(i) == true) {
         switch(i) {   // make sure item is in the 'new' array already 
                        // ie. (avoid adding it twice)
            case 0: 
               if (!allChecked.includes("GP Fixit 7"))
                  allChecked.push("GP Fixit 7")
               break
            case 1: 
               if (!allChecked.includes("Fixit 7"))
                  allChecked.push("Fixit 7")
               break
            case 2: 
               if (!allChecked.includes("GP Fixit 8"))
                  allChecked.push("GP Fixit 8")
               break
            case 3: 
               if (!allChecked.includes("Fixit 8"))
                  allChecked.push("Fixit 8")
               break
            case 4: 
               if (!allChecked.includes("Perf"))
                  allChecked.push("Perf")
               break
        } // switch
    //console.log("level3 all current choices: " + allChecked)
    //console.log("what was previously in database: " + level3Results)
        } // if getValue is true
    } // for loop

     // 2. *** Now check to see if the contents of two arrays 
     // (all currently checked allChecked and from DB level2Results)
     // are the same. 
     // If they are NOT the same, get the elements that are different 
     // (ie. not from the database)- so essentially pick out the 
     // new ones the user added this runtime.
 
     diffFromDatabase = []
     if(!(JSON.stringify(allChecked.sort())==JSON.stringify(level3Results.sort()))) {
        diffFromDatabase = allChecked.diff(level3Results) 
     //console.log("L3 REg diff from DB is " + diffFromDatabase)
            
    // 3. Now insert the difference (new items that were newly checked) into the DB
        for (i = 0; i < diffFromDatabase.length; i++) {
            query = "INSERT INTO assignments (netID,assignmentName,level) VALUES ('" + netID + "','" + diffFromDatabase[i] + "'," + 3 + ")"
            req = Ajax("https://ormond.creighton.edu/courses/375/ajax-connection.php", "POST", "host=ormond.creighton.edu&user=clc90595&pass=BIA375&database=clc90595&query=" + query)
            if (req.status == 200) { //transit worked.
            //console.log(`added to db: diffFromDatabase[i] when i = ${i}: ${diffFromDatabase[i]} `)
                if (req.responseText == 500) {   // means the insert succeeded
                    //let result = JSON.parse(req.responseText)
                    NSB.MsgBox("Your changes have been saved.")
                } else
                    NSB.MsgBox("There was a problem saving your changes. Please close the app and try again.")
            } else {
                // transit error
                NSB.MsgBox("Save error: " + req.status)
            }
        }  // for loop
    } // if JSON.stringify...
    
  /* ****** LEVEL 3AB Data Save to DB ************** */
    // 1. Get all of the items that are currently checked for Level 2 AB 
    allChecked = []
    for (i = 0; i < 3; i++) { // 3  checkboxes in the Level 1 AB 
      if (chkbxAB3.getValue(i) == true) {
         switch(i) {   // make sure item is in the 'new' array already 
                        // ie. (avoid adding it twice)
            case 0: 
               if (!allChecked.includes("ExtraXP Fixit 7"))
                  allChecked.push("ExtraXP Fixit 7")
               break
            case 1: 
               if (!allChecked.includes("ExtraXP Fixit 8"))
                  allChecked.push("ExtraXP Fixit 8")
               break

            case 2: 
               if (!allChecked.includes("Level Up Fixit"))
                  allChecked.push("Level Up Fixit")
               break
        } // switch
    //console.log("level3AB all current choices: " + allChecked)
    //console.log("what was previously in database: " + level3ResultsAB)
        } // if getValue is true
    } // for loop

     // 2. *** Now check to see if the contents of two arrays 
     // (all currently checked allChecked and from DB level1Results)
     // are the same. 
     // If they are NOT the same, get the elements that are different 
     // (ie. not from the database)- so essentially pick out the 
     // new ones the user added this runtime.
 
     diffFromDatabase = []
     if(!(JSON.stringify(allChecked.sort())==JSON.stringify(level3ResultsAB.sort()))) {
        diffFromDatabase = allChecked.diff(level3ResultsAB) 
     console.log("L3AB diff from DB is " + diffFromDatabase)
            
    // 3. Now insert the difference (new items that were newly checked) into the DB
        for (i = 0; i < diffFromDatabase.length; i++) {
            query = "INSERT INTO assignmentsab (netID,assignABName,level) VALUES ('" + netID + "','" + diffFromDatabase[i] + "'," + 3 + ")"
            req = Ajax("https://ormond.creighton.edu/courses/375/ajax-connection.php", "POST", "host=ormond.creighton.edu&user=clc90595&pass=BIA375&database=clc90595&query=" + query)
            if (req.status == 200) { //transit worked.
            console.log(`added to db: diffFromDatabase[i] when i = ${i}: ${diffFromDatabase[i]} `)
                if (req.responseText == 500) {   // means the insert succeeded
                    //let result = JSON.parse(req.responseText)
                    NSB.MsgBox("Your changes have been saved.")
                } else
                    NSB.MsgBox("There was a problem saving your changes. Please close the app and try again.")
            } else {
                // transit error
                NSB.MsgBox("Save error: " + req.status)
            }
        }  // for loop
    } // if JSON.stringify...


// FINISH for Levels 4, 5, 6, 7




} // event

